      ******************************************************************
      * Ziege.cbl                                           28.03.2003 *
      *                         Ziegenproblem                          *
      *                                                                *      
      * microfocus COBOL                                               *      
      ******************************************************************

      ******************************************************************
       WORKING-STORAGE SECTION.
      ******************************************************************

       01 Variable-77.
          07 Start-Zeit-3          pic 9(3)       value zero.
          07 z1                    pic 9(6)       value zero.
          07 z2                    pic 9(6)       value zero.
          07 z3                    pic 9(6)       value zero.
          07 z4                    pic 9(6)       value zero.
          07 z1-Prozent            pic 9(9)V9(4)  value zero.
          07 z2-Prozent            pic 9(9)v9(4)  value zero.
          07 z3-Prozent            pic 9(9)v9(4)  value zero.
          07 z99-Prozent           pic 9(9)v9(4)  value zero.
          07 z1-Prozent-Display    pic zz9.9(4)   value zero.
          07 z2-Prozent-Display    pic zz9.9(4)   value zero.
          07 z3-Prozent-Display    pic zz9.9(4)   value zero.
          07 z99-Prozent-Display   pic zz9.9(4)   value zero.
          07 Zaehler               pic 9(6)       value zero.
          07 Zufallszahl1-v        pic v9(9)      value zero.
          07 Karte-1               pic x          value space.
          07 Karte-2               pic x          value space.
          07 Karte-3               pic x          value space.
          07 Auswahl               pic 9          value zero.
          07 Auto-Zaehler1         pic 9(6)       value zero.
          07 Auto-Zaehler2         pic 9(6)       value zero.
          07 Auto-Zaehler99        pic 9(6)       value zero.
          07 Schalter              pic x          value space.

       01 Zufallszahl-Zerleger.
          05 Filler            pic 9    value zero.
          05 Filler            pic 9    value zero.
          05 Filler            pic 9    value zero.
          05 Zufallszahl-1     pic 9    value zero.
          05 Filler            pic 9    value zero.
          05 Zufallszahl-2     pic 9    value zero.
          05 Filler            pic 9    value zero.
          05 Filler            pic 9    value zero.
          05 Filler            pic 9    value zero.

      ******************************************************************
       PROCEDURE DIVISION.
      ******************************************************************

       main section.

           display "Z i e g e n p r o b l e m"      at 0101.
           display "Zufallszahl 1: Autos verteilt:" at 0301.
           display "www.vaeter-aktuell.de"          at 0356.
           display "Auto bei A"                     at 0501.
           display "Auto bei B"                     at 0601.
           display "Auto bei C"                     at 0701.
           display "Summe"                          at 0801.
           display "Zufallszahl 2: Autos gewonnen:" at 1101.
           display "Tippen ohne Wechsel"            at 1301.
           display "Tippen mit Wechsel"             at 1401.
           display "Summe aus Methoden"             at 1501.
           display "Enthaltene Runtimes copyright Micro Focus"
                                                    at 2501.

           perform until Schalter <> space

             initialize Variable-77 Zufallszahl-Zerleger
             perform until Zaehler >= 300
               add 1 to Zaehler
               perform 900-Zufallszahl
               perform 100-Karten-mischen
               perform 900-Zufallszahl
               perform 200-Karte-waehlen
               perform 300-Tippen-ohne-Wechsel
               perform 400-Tippen-mit-Wechsel
             end-perform

             perform 110-Auswertung-Prozent
             perform 310-Auswertung-Prozent
             perform 410-Auswertung-Prozent
             perform 510-Auswertung-Prozent-Summe

             move space to Schalter
             display "Return = nochmal" at 2001
             display "e = Ende  "       at 2021
             accept Schalter
           end-perform

           stop run.

       100-Karten-mischen section.

           evaluate Zufallszahl-1
             when 1 move "A" to Karte-1 move "Z" to Karte-2 Karte-3
             when 4 move "A" to Karte-1 move "Z" to Karte-2 Karte-3
             when 7 move "A" to Karte-1 move "Z" to Karte-2 Karte-3
             when 2 move "A" to Karte-2 move "Z" to Karte-1 Karte-3
             when 5 move "A" to Karte-2 move "Z" to Karte-1 Karte-3
             when 8 move "A" to Karte-2 move "Z" to Karte-1 Karte-3
             when 3 move "A" to Karte-3 move "Z" to Karte-1 Karte-2
             when 6 move "A" to Karte-3 move "Z" to Karte-1 Karte-2
             when 9 move "A" to Karte-3 move "Z" to Karte-1 Karte-2
             when other perform 900-Zufallszahl
                          go to 100-Karten-mischen
           end-evaluate

           evaluate Zufallszahl-1
             when 1 add 1 to z1 z4
             when 4 add 1 to z1 z4
             when 7 add 1 to z1 z4
             when 2 add 1 to z2 z4
             when 5 add 1 to z2 z4
             when 8 add 1 to z2 z4
             when 3 add 1 to z3 z4
             when 6 add 1 to z3 z4
             when 9 add 1 to z3 z4
           end-evaluate

           display z1           at 0522
           display z2           at 0622
           display z3           at 0722
           display z4           at 0822
           exit section.

       110-Auswertung-Prozent section.
           multiply z1 by 100 giving z1-Prozent
           multiply z2 by 100 giving z2-Prozent
           multiply z3 by 100 giving z3-Prozent
           divide z1-Prozent by z4 giving z1-Prozent rounded
           divide z2-Prozent by z4 giving z2-Prozent rounded
           divide z3-Prozent by z4 giving z3-Prozent rounded
           move z1-Prozent to z1-Prozent-Display
           move z2-Prozent to z2-Prozent-Display
           move z3-Prozent to z3-Prozent-Display
           display z1-Prozent-Display at 0530
           display z2-Prozent-Display at 0630
           display z3-Prozent-Display at 0730
           add z1-Prozent z2-Prozent z3-Prozent to z99-Prozent
           move z99-Prozent to z99-Prozent-Display
           display z99-Prozent-Display at 0830
           display "%" at 0539
           display "%" at 0639
           display "%" at 0739
           display "%" at 0839
           exit section.

       200-Karte-waehlen section.

           move zero to Auswahl

           evaluate Zufallszahl-1
             when 1 move 1 to Auswahl
             when 4 move 1 to Auswahl
             when 7 move 1 to Auswahl
             when 2 move 2 to Auswahl
             when 5 move 2 to Auswahl
             when 8 move 2 to Auswahl
             when 3 move 3 to Auswahl
             when 6 move 3 to Auswahl
             when 9 move 3 to Auswahl
             when other perform 900-Zufallszahl
                          go to 200-Karte-waehlen
           end-evaluate
           exit section.

       300-Tippen-ohne-Wechsel section.

           if Auswahl = 1 and Karte-1 = "A"
              add 1 to Auto-Zaehler1 Auto-Zaehler99
           end-if

           if Auswahl = 2 and Karte-2 = "A"
              add 1 to Auto-Zaehler1 Auto-Zaehler99
           end-if

           if Auswahl = 3 and Karte-3 = "A"
              add 1 to Auto-Zaehler1 Auto-Zaehler99
           end-if

           display Auto-Zaehler1 at 1322
           exit section.

       310-Auswertung-Prozent section.
           multiply Auto-Zaehler1 by 100 giving z1-Prozent
           divide z1-Prozent by z4 giving z1-Prozent rounded
           move z1-Prozent to z1-Prozent-Display
           display z1-Prozent-Display at 1330
           display "%" at 1339
           initialize z99-Prozent
           add z1-Prozent to z99-Prozent
           exit section.

       400-Tippen-mit-Wechsel section.

       *> Kommentar:
       *> Der Moderator wei, hinter welcher Tr sich das Auto befindet.
       *> Er ffnet eine Tr, hinter der sich eine Ziege befindet.
       *> Der Kandidat wechselt.

       *> Entscheidungsmatrix:
           evaluate Karte-1 also Karte-2 also Karte-3 also Auswahl
              when "A" also "Z" also "Z" also 1 move 3 to Auswahl *> -
              when "Z" also "A" also "Z" also 1 move 2 to Auswahl *> +
              when "Z" also "Z" also "A" also 1 move 3 to Auswahl *> +
              when "A" also "Z" also "Z" also 2 move 1 to Auswahl *> +
              when "Z" also "A" also "Z" also 2 move 1 to Auswahl *> -
              when "Z" also "Z" also "A" also 2 move 3 to Auswahl *> +
              when "A" also "Z" also "Z" also 3 move 1 to Auswahl *> +
              when "Z" also "A" also "Z" also 3 move 2 to Auswahl *> +
              when "Z" also "Z" also "A" also 3 move 2 to Auswahl *> -
              when other
                     display "interner Programmfehler bei 400"
                     display "Karte-1 " Karte-1
                     display "Karte-2 " Karte-2
                     display "Karte-3 " Karte-3
                     display "Auswahl " Auswahl
                     stop run
           end-evaluate

           if Auswahl = 1 and Karte-1 = "A"
              add 1 to Auto-Zaehler2 Auto-Zaehler99
           end-if

           if Auswahl = 2 and Karte-2 = "A"
              add 1 to Auto-Zaehler2 Auto-Zaehler99
           end-if

           if Auswahl = 3 and Karte-3 = "A"
              add 1 to Auto-Zaehler2 Auto-Zaehler99
           end-if

           display Auto-Zaehler2  at 1422
           display Auto-Zaehler99 at 1522
           exit section.

       410-Auswertung-Prozent section.
           multiply Auto-Zaehler2 by 100 giving z1-Prozent
           divide z1-Prozent by z4 giving z1-Prozent rounded
           move z1-Prozent to z1-Prozent-Display
           display z1-Prozent-Display at 1430
           display "%" at 1439
           add z1-Prozent to z99-Prozent
           exit section.

       510-Auswertung-Prozent-Summe section.
           move z99-Prozent to z99-Prozent-Display
           display z99-Prozent-Display at 1530
           display "%" at 1539
           exit section.

       900-Zufallszahl section.
           accept Start-Zeit-3 from time
           compute Zufallszahl1-v = function random
           multiply Zufallszahl1-v by Start-Zeit-3 giving Zufallszahl1-v
           move Zufallszahl1-v to Zufallszahl-Zerleger
           exit section.

